DROP MATERIALIZED VIEW IF EXISTS ocs2d.ocs2d_enaf_somme_2010_2021;
CREATE MATERIALIZED VIEW ocs2d.ocs2d_enaf_somme_2010_2021 AS
SELECT
  gid,
  cs1_2010,
  libcs1_2010,
  cs2_2010,
  libcs2_2010,
  cs3_2010,
  libcs3_2010,
  us1_2010,
  libus1_2010,
  us2_2010,
  libus2_2010,
  us3_2010,
  libus3_2010,
  CASE
      WHEN LEFT(ocs.us3_2010,5) IN ('US1.1','US1.4') THEN 'Agricole'
      WHEN (LEFT(ocs.us3_2010,5) = 'US1.3' AND LEFT(ocs.cs3_2010,3) = 'CS1.1') OR LEFT(ocs.us3_2010,3) IN ('US2','US3') THEN 'Activités'
      WHEN LEFT(ocs.us3_2010,3) = 'US5' THEN 'Habitat'
      WHEN LEFT(ocs.us3_2010,5) = 'US1.2' OR (LEFT(ocs.us3_2010,3) = 'US7' AND LEFT(ocs.cs3_2010,3) = 'CS4') THEN 'Forêt'
      WHEN LEFT(ocs.us3_2010,5) IN ('US4.1','US4.2','US4.3') OR (LEFT(ocs.us3_2010,5) IN ('US4.4','US4.5') AND LEFT(ocs.cs3_2010,3) = 'CS1') THEN 'Infrastructure'
      WHEN LEFT(ocs.us3_2010,3) IN ('US6','US7') AND LEFT(ocs.cs3_2010,3) = 'CS1' THEN 'Inconnu'
      WHEN (LEFT(ocs.us3_2010,5) IN ('US4.4','US4.5','US6.1','US6.2') AND LEFT(ocs.cs3_2010,3) IN ('CS2','CS3','CS4','CS5','CS6')) OR (LEFT(ocs.us3_2010,3) = 'US7' AND LEFT(ocs.cs3_2010,3) != 'CS4') OR (LEFT(ocs.us3_2010,5) = 'US1.3' AND LEFT(ocs.cs3_2010,3) != 'CS1.1') THEN 'Naturel'
      ELSE 'Erreur classement'
    END AS class_enaf_2010,
    CASE
      WHEN LEFT(ocs.us3_2010,5) IN ('US1.1','US1.4') THEN 'NAF'
      WHEN (LEFT(ocs.us3_2010,5) = 'US1.3' AND LEFT(ocs.cs3_2010,3) = 'CS1.1') OR LEFT(ocs.us3_2010,3) IN ('US2','US3') THEN 'Urbanisé'
      WHEN LEFT(ocs.us3_2010,3) = 'US5' THEN 'Urbanisé'
      WHEN LEFT(ocs.us3_2010,5) = 'US1.2' OR (LEFT(ocs.us3_2010,3) = 'US7' AND LEFT(ocs.cs3_2010,3) = 'CS4') THEN 'NAF'
      WHEN LEFT(ocs.us3_2010,5) IN ('US4.1','US4.2','US4.3') OR (LEFT(ocs.us3_2010,5) IN ('US4.4','US4.5') AND LEFT(ocs.cs3_2010,3) = 'CS1') THEN 'Urbanisé'
      WHEN LEFT(ocs.us3_2010,3) IN ('US6','US7') AND LEFT(ocs.cs3_2010,3) = 'CS1' THEN 'Urbanisé'
      WHEN (LEFT(ocs.us3_2010,5) IN ('US4.4','US4.5','US6.1','US6.2') AND LEFT(ocs.cs3_2010,3) IN ('CS2','CS3','CS4','CS5','CS6')) OR (LEFT(ocs.us3_2010,3) = 'US7' AND LEFT(ocs.cs3_2010,3) != 'CS4') OR (LEFT(ocs.us3_2010,5) = 'US1.3' AND LEFT(ocs.cs3_2010,3) != 'CS1.1') THEN 'NAF'
      ELSE 'Indéterminé'
    END AS class_urba_2010,
  cs1_2021,
  libcs1_2021,
  cs2_2021,
  libcs2_2021,
  cs3_2021,
  libcs3_2021,
  us1_2021,
  libus1_2021,
  us2_2021,
  libus2_2021,
  us3_2021,
  libus3_2021,
  CASE
    WHEN LEFT(ocs.us3_2021,5) IN ('US1.1','US1.4') THEN 'Agricole'
    WHEN (LEFT(ocs.us3_2021,5) = 'US1.3' AND LEFT(ocs.cs3_2021,3) = 'CS1.1') OR LEFT(ocs.us3_2021,3) IN ('US2','US3') THEN 'Activités'
    WHEN LEFT(ocs.us3_2021,3) = 'US5' THEN 'Habitat'
    WHEN LEFT(ocs.us3_2021,5) = 'US1.2' OR (LEFT(ocs.us3_2021,3) = 'US7' AND LEFT(ocs.cs3_2021,3) = 'CS4') THEN 'Forêt'
    WHEN LEFT(ocs.us3_2021,5) IN ('US4.1','US4.2','US4.3') OR (LEFT(ocs.us3_2021,5) IN ('US4.4','US4.5') AND LEFT(ocs.cs3_2021,3) = 'CS1') THEN 'Infrastructure'
    WHEN LEFT(ocs.us3_2021,3) IN ('US6','US7') AND LEFT(ocs.cs3_2021,3) = 'CS1' THEN 'Inconnu'
    WHEN (LEFT(ocs.us3_2021,5) IN ('US4.4','US4.5','US6.1','US6.2') AND LEFT(ocs.cs3_2021,3) IN ('CS2','CS3','CS4','CS5','CS6')) OR (LEFT(ocs.us3_2021,3) = 'US7' AND LEFT(ocs.cs3_2021,3) != 'CS4') OR (LEFT(ocs.us3_2021,5) = 'US1.3' AND LEFT(ocs.cs3_2021,3) != 'CS1.1') THEN 'Naturel'
    ELSE 'Erreur classement'
  END AS class_enaf_2021,
  CASE
    WHEN LEFT(ocs.us3_2021,5) IN ('US1.1','US1.4') THEN 'NAF'
    WHEN (LEFT(ocs.us3_2021,5) = 'US1.3' AND LEFT(ocs.cs3_2021,3) = 'CS1.1') OR LEFT(ocs.us3_2021,3) IN ('US2','US3') THEN 'Urbanisé'
    WHEN LEFT(ocs.us3_2021,3) = 'US5' THEN 'Urbanisé'
    WHEN LEFT(ocs.us3_2021,5) = 'US1.2' OR (LEFT(ocs.us3_2021,3) = 'US7' AND LEFT(ocs.cs3_2021,3) = 'CS4') THEN 'NAF'
    WHEN LEFT(ocs.us3_2021,5) IN ('US4.1','US4.2','US4.3') OR (LEFT(ocs.us3_2021,5) IN ('US4.4','US4.5') AND LEFT(ocs.cs3_2021,3) = 'CS1') THEN 'Urbanisé'
    WHEN LEFT(ocs.us3_2021,3) IN ('US6','US7') AND LEFT(ocs.cs3_2021,3) = 'CS1' THEN 'Urbanisé'
    WHEN (LEFT(ocs.us3_2021,5) IN ('US4.4','US4.5','US6.1','US6.2') AND LEFT(ocs.cs3_2021,3) IN ('CS2','CS3','CS4','CS5','CS6')) OR (LEFT(ocs.us3_2021,3) = 'US7' AND LEFT(ocs.cs3_2021,3) != 'CS4') OR (LEFT(ocs.us3_2021,5) = 'US1.3' AND LEFT(ocs.cs3_2021,3) != 'CS1.1') THEN 'NAF'
    ELSE 'Indéterminé'
  END AS class_urba_2021,
  codgeo, -- à adapter selon la table des limites administratives
  libcom, -- à adapter selon la table des limites administratives
  dep, -- à adapter selon la table des limites administratives
  epci, -- à adapter selon la table des limites administratives
  libepci, -- à adapter selon la table des limites administratives
  nature_epci, -- à adapter selon la table des limites administratives
  scot_idurba, -- à adapter selon la table des limites administratives
  scot_nom, -- à adapter selon la table des limites administratives
  ST_Area(ocs.geom) AS surf_m2,
  geom::geometry(Polygon,2154) AS geom
FROM
    ocs2d.ocs2d_com_somme_2010_2021 AS ocs -- couche OCS2d déjà découpé selon les périmètres administratifs
;