DROP MATERIALIZED VIEW IF EXISTS ocs2d.ocs2d_zan_somme_2010_2021;
CREATE MATERIALIZED VIEW ocs2d.ocs2d_zan_somme_2010_2021 AS
SELECT
  gid,
  cs1_2010,
  libcs1_2010,
  cs2_2010,
  libcs2_2010,
  cs3_2010,
  libcs3_2010,
  us1_2010,
  libus1_2010,
  us2_2010,
  libus2_2010,
  us3_2010,
  libus3_2010,
  CASE 
    WHEN ocs.cs3_2010 = 'CS1.1.1' THEN 1
    WHEN ocs.cs3_2010 = 'CS1.1.2' THEN 2
    WHEN ocs.cs3_2010 = 'CS1.2.1' AND LEFT(ocs.us3_2010,5) != 'US1.3' THEN 3
    WHEN ocs.cs3_2010 = 'CS1.2.2' THEN 4
    WHEN LEFT(ocs.cs3_2010,3) = 'CS6' AND (LEFT(ocs.us3_2010,3) IN ('US2','US3','US4','US5') OR LEFT(ocs.us3_2010,5) = 'US6.1' OR LEFT(ocs.us3_2010,7) = 'US6.2.1') THEN 5
    WHEN LEFT(ocs.cs3_2010,3) = 'CS2' OR (LEFT(ocs.cs3_2010,3) = 'CS3' AND ocs.us3_2010 != 'US1.4.0') OR (ocs.cs3_2010 = 'CS1.2.1' AND LEFT(ocs.us3_2010,5) = 'US1.3') THEN 6
    WHEN (LEFT(ocs.cs3_2010,3) IN ('CS4','CS5','CS6') AND LEFT(ocs.us3_2010,5) IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2010,3) = 'CS3' AND LEFT(ocs.us3_2010,5) = 'US1.4') THEN 7
    WHEN (LEFT(ocs.cs3_2010,3) IN ('CS4','CS5') AND LEFT(ocs.us3_2010,5) NOT IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2010,3) = 'CS6' AND (LEFT(ocs.us3_2010,5) IN ('US1.3','US7.0') OR LEFT(ocs.us3_2010,7) IN ('US6.2.2','US6.2.3'))) THEN 8
    ELSE 99
  END AS code_zan_2010,
  CASE 
    WHEN ocs.cs3_2010 = 'CS1.1.1' THEN 'Zones bâties'
    WHEN ocs.cs3_2010 = 'CS1.1.2' THEN 'Surfaces imperméables'
    WHEN ocs.cs3_2010 = 'CS1.2.1' AND LEFT(ocs.us3_2010,5) != 'US1.3' THEN 'Surface perméables matériaux minéraux'
    WHEN ocs.cs3_2010 = 'CS1.2.2' THEN 'Surface perméables matériaux composites'
    WHEN LEFT(ocs.cs3_2010,3) = 'CS6' AND (LEFT(ocs.us3_2010,3) IN ('US2','US3','US4','US5') OR LEFT(ocs.us3_2010,5) = 'US6.1' OR LEFT(ocs.us3_2010,7) = 'US6.2.1') THEN 'Végétation herbacée'
    WHEN LEFT(ocs.cs3_2010,3) = 'CS2' OR (LEFT(ocs.cs3_2010,3) = 'CS3' AND ocs.us3_2010 != 'US1.4.0') OR (ocs.cs3_2010 = 'CS1.2.1' AND LEFT(ocs.us3_2010,5) = 'US1.3') THEN 'Sols nus et surfaces en eau'
    WHEN (LEFT(ocs.cs3_2010,3) IN ('CS4','CS5','CS6') AND LEFT(ocs.us3_2010,5) IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2010,3) = 'CS3' AND LEFT(ocs.us3_2010,5) = 'US1.4') THEN 'Cultures/Aquaculture'
    WHEN (LEFT(ocs.cs3_2010,3) IN ('CS4','CS5') AND LEFT(ocs.us3_2010,5) NOT IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2010,3) = 'CS6' AND (LEFT(ocs.us3_2010,5) IN ('US1.3','US7.0') OR LEFT(ocs.us3_2010,7) IN ('US6.2.2','US6.2.3'))) THEN 'Surfaces naturelles ou végétalisées'
    ELSE 'Erreur classement'
  END AS class_zan_2010,
   CASE 
    WHEN ocs.cs3_2010 = 'CS1.1.1' THEN 'Artif'
    WHEN ocs.cs3_2010 = 'CS1.1.2' THEN 'Artif'
    WHEN ocs.cs3_2010 = 'CS1.2.1' AND LEFT(ocs.us3_2010,5) != 'US1.3' THEN 'Artif'
    WHEN ocs.cs3_2010 = 'CS1.2.2' THEN 'Artif'
    WHEN LEFT(ocs.cs3_2010,3) = 'CS6' AND (LEFT(ocs.us3_2010,3) IN ('US2','US3','US4','US5') OR LEFT(ocs.us3_2010,5) = 'US6.1' OR LEFT(ocs.us3_2010,7) = 'US6.2.1') THEN 'Artif'
    WHEN LEFT(ocs.cs3_2010,3) = 'CS2' OR (LEFT(ocs.cs3_2010,3) = 'CS3' AND ocs.us3_2010 != 'US1.4.0') OR (ocs.cs3_2010 = 'CS1.2.1' AND LEFT(ocs.us3_2010,5) = 'US1.3') THEN 'Non Artif'
    WHEN (LEFT(ocs.cs3_2010,3) IN ('CS4','CS5','CS6') AND LEFT(ocs.us3_2010,5) IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2010,3) = 'CS3' AND LEFT(ocs.us3_2010,5) = 'US1.4') THEN 'Non Artif'
    WHEN (LEFT(ocs.cs3_2010,3) IN ('CS4','CS5') AND LEFT(ocs.us3_2010,5) NOT IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2010,3) = 'CS6' AND (LEFT(ocs.us3_2010,5) IN ('US1.3','US7.0') OR LEFT(ocs.us3_2010,7) IN ('US6.2.2','US6.2.3'))) THEN 'Non Artif'
    ELSE 'Indéterminé'
  END AS class_artif_2010,
  cs1_2021,
  libcs1_2021,
  cs2_2021,
  libcs2_2021,
  cs3_2021,
  libcs3_2021,
  us1_2021,
  libus1_2021,
  us2_2021,
  libus2_2021,
  us3_2021,
  libus3_2021,
  CASE 
    WHEN ocs.cs3_2021 = 'CS1.1.1' THEN 1
    WHEN ocs.cs3_2021 = 'CS1.1.2' THEN 2
    WHEN ocs.cs3_2021 = 'CS1.2.1' AND LEFT(ocs.us3_2021,5) != 'US1.3' THEN 3
    WHEN ocs.cs3_2021 = 'CS1.2.2' THEN 4
    WHEN LEFT(ocs.cs3_2021,3) = 'CS6' AND (LEFT(ocs.us3_2021,3) IN ('US2','US3','US4','US5') OR LEFT(ocs.us3_2021,5) = 'US6.1' OR LEFT(ocs.us3_2021,7) = 'US6.2.1') THEN 5
    WHEN LEFT(ocs.cs3_2021,3) = 'CS2' OR (LEFT(ocs.cs3_2021,3) = 'CS3' AND ocs.us3_2021 != 'US1.4.0') OR (ocs.cs3_2021 = 'CS1.2.1' AND LEFT(ocs.us3_2021,5) = 'US1.3') THEN 6
    WHEN (LEFT(ocs.cs3_2021,3) IN ('CS4','CS5','CS6') AND LEFT(ocs.us3_2021,5) IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2021,3) = 'CS3' AND LEFT(ocs.us3_2021,5) = 'US1.4') THEN 7
    WHEN (LEFT(ocs.cs3_2021,3) IN ('CS4','CS5') AND LEFT(ocs.us3_2021,5) NOT IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2021,3) = 'CS6' AND (LEFT(ocs.us3_2021,5) IN ('US1.3','US7.0') OR LEFT(ocs.us3_2021,7) IN ('US6.2.2','US6.2.3'))) THEN 8
    ELSE 99
  END AS code_zan_2021,
  CASE 
    WHEN ocs.cs3_2021 = 'CS1.1.1' THEN 'Zones bâties'
    WHEN ocs.cs3_2021 = 'CS1.1.2' THEN 'Surfaces imperméables'
    WHEN ocs.cs3_2021 = 'CS1.2.1' AND LEFT(ocs.us3_2021,5) != 'US1.3' THEN 'Surface perméables matériaux minéraux'
    WHEN ocs.cs3_2021 = 'CS1.2.2' THEN 'Surface perméables matériaux composites'
    WHEN LEFT(ocs.cs3_2021,3) = 'CS6' AND (LEFT(ocs.us3_2021,3) IN ('US2','US3','US4','US5') OR LEFT(ocs.us3_2021,5) = 'US6.1' OR LEFT(ocs.us3_2021,7) = 'US6.2.1') THEN 'Végétation herbacée'
    WHEN LEFT(ocs.cs3_2021,3) = 'CS2' OR (LEFT(ocs.cs3_2021,3) = 'CS3' AND ocs.us3_2021 != 'US1.4.0') OR (ocs.cs3_2021 = 'CS1.2.1' AND LEFT(ocs.us3_2021,5) = 'US1.3') THEN 'Sols nus et surfaces en eau'
    WHEN (LEFT(ocs.cs3_2021,3) IN ('CS4','CS5','CS6') AND LEFT(ocs.us3_2021,5) IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2021,3) = 'CS3' AND LEFT(ocs.us3_2021,5) = 'US1.4') THEN 'Cultures/Aquaculture'
    WHEN (LEFT(ocs.cs3_2021,3) IN ('CS4','CS5') AND LEFT(ocs.us3_2021,5) NOT IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2021,3) = 'CS6' AND (LEFT(ocs.us3_2021,5) IN ('US1.3','US7.0') OR LEFT(ocs.us3_2021,7) IN ('US6.2.2','US6.2.3'))) THEN 'Surfaces naturelles ou végétalisées'
    ELSE 'Erreur classement'
  END AS class_zan_2021,
   CASE 
    WHEN ocs.cs3_2021 = 'CS1.1.1' THEN 'Artif'
    WHEN ocs.cs3_2021 = 'CS1.1.2' THEN 'Artif'
    WHEN ocs.cs3_2021 = 'CS1.2.1' AND LEFT(ocs.us3_2021,5) != 'US1.3' THEN 'Artif'
    WHEN ocs.cs3_2021 = 'CS1.2.2' THEN 'Artif'
    WHEN LEFT(ocs.cs3_2021,3) = 'CS6' AND (LEFT(ocs.us3_2021,3) IN ('US2','US3','US4','US5') OR LEFT(ocs.us3_2021,5) = 'US6.1' OR LEFT(ocs.us3_2021,7) = 'US6.2.1') THEN 'Artif'
    WHEN LEFT(ocs.cs3_2021,3) = 'CS2' OR (LEFT(ocs.cs3_2021,3) = 'CS3' AND ocs.us3_2021 != 'US1.4.0') OR (ocs.cs3_2021 = 'CS1.2.1' AND LEFT(ocs.us3_2021,5) = 'US1.3') THEN 'Non Artif'
    WHEN (LEFT(ocs.cs3_2021,3) IN ('CS4','CS5','CS6') AND LEFT(ocs.us3_2021,5) IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2021,3) = 'CS3' AND LEFT(ocs.us3_2021,5) = 'US1.4') THEN 'Non Artif'
    WHEN (LEFT(ocs.cs3_2021,3) IN ('CS4','CS5') AND LEFT(ocs.us3_2021,5) NOT IN ('US1.1','US1.2','US1.4')) OR (LEFT(ocs.cs3_2021,3) = 'CS6' AND (LEFT(ocs.us3_2021,5) IN ('US1.3','US7.0') OR LEFT(ocs.us3_2021,7) IN ('US6.2.2','US6.2.3'))) THEN 'Non Artif'
    ELSE 'Indéterminé'
  END AS class_artif_2021,
  codgeo, -- à adapter selon la table des limites administratives
  libcom, -- à adapter selon la table des limites administratives
  dep, -- à adapter selon la table des limites administratives
  epci, -- à adapter selon la table des limites administratives
  libepci, -- à adapter selon la table des limites administratives
  nature_epci, -- à adapter selon la table des limites administratives
  scot_idurba, -- à adapter selon la table des limites administratives
  scot_nom, -- à adapter selon la table des limites administratives
  ST_Area(ocs.geom) AS surf_m2,
  geom::geometry(Polygon,2154) AS geom
FROM
    ocs2d.ocs2d_com_somme_2010_2021 AS ocs
;